.586
.MODEL flat, stdcall

OPTION CASEMAP:NONE   ;Case sensitive
.nolist
Include windows.inc
Include kernel32.inc
Include masm32.inc
Include fpu.inc
.listall

IncludeLib kernel32.lib
IncludeLib masm32.lib
IncludeLib fpu.lib

.DATA
Msg1    DB "Please enter a floting point number: ",0
Msg2    DB "You Typed: ",0
Msg4    DB "Press Enter to Exit ",0
CRLF    DB 0dH,0aH,0
Msg5    db "The number entered to 6 decimals was: ",0
Msg6    db "The number squared is: ",0
errin   db "Error converting input number",0dh,0ah,0
errmul  db "Error multiplying number",0dh,0ah,0
lbraket db "<",0
rbraket db ">",0
.DATA?
inbuf   DB 100 DUP (?)
outbuf  DB 100 DUP (?)
fnum    tbyte ?
.CODE

Program:

  Call Main
  Invoke ExitProcess,0

Main Proc
    XOR eax,eax
    invoke StdOut,addr Msg1
    invoke StdIn,addr inbuf,LengthOf inbuf
    mov esi,offset inbuf
    .repeat     ; strip off the crlf
        lodsb
        cmp al,0dh  ; search for cr
    .until zero?
    dec esi
    mov byte ptr [esi], 0
       
    invoke StdOut,addr Msg2
    invoke StdOut,addr lbraket
    invoke StdOut,addr inbuf
    invoke StdOut,addr rbraket
    invoke StdOut,addr CRLF
    invoke StdOut,addr CRLF
    
    ; look in FPULIB.HLP for information on the floating point functions
    invoke FpuAtoFL,addr inbuf,addr fnum,DEST_MEM
    .if eax==0
        invoke StdOut,addr errin
        jmp wrap
    .endif
    invoke FpuFLtoA,addr fnum,6,addr outbuf,SRC1_REAL or SRC2_DIMM       
    ; should test for failure here
        
    invoke StdOut,addr Msg5
    invoke StdOut,addr outbuf
    invoke StdOut,addr CRLF
    
    invoke FpuMul,addr fnum,addr fnum,addr fnum,SRC1_REAL or SRC2_REAL or DEST_MEM
    .if eax==0
        invoke StdOut,addr errin
        jmp wrap
    .endif
    invoke FpuFLtoA,addr fnum,6,addr outbuf,SRC1_REAL or SRC2_DIMM       
    ; should test for failure here
       
    invoke StdOut,addr Msg6
    invoke StdOut,addr outbuf
    invoke StdOut,addr CRLF

wrap:
    invoke StdOut,addr CRLF
    invoke StdOut,addr Msg4
    invoke StdIn,addr inbuf,Lengthof inbuf
    RET
Main EndP

End Program
